#pragma once

#include "Program.hpp"

namespace render::gl::pass {
    /// Solid colors pass
    class ColorProgram: public Program {
    public:
        ColorProgram();
        ~ColorProgram();

        void setup(Renderer *, const glm::mat4& modelMatrix, const glm::vec4& color);

    protected:
        std::string getName() const override;
        void setMVP(const GLfloat *matrix);
        void setCol(const GLfloat *color);

    private:
        GLuint MVPMatrixID;
        GLuint ColID;
    };
}
