#pragma once

#include "VoxelProgram.hpp"

namespace render::gl::pass {
    /// Unique voxels pass
    class TerrainProgram: public VoxelProgram {
    public:
        TerrainProgram(const options &opts);
        ~TerrainProgram();

        void setup(const glm::mat4& modelMatrix, const glm::vec4& sphereProj, float curvature);
        void unsetCurvature();
        void setup(const glm::mat4 &modelMatrix);

    protected:
        void setModel(const GLfloat *matrix);

    private:
        GLuint ModelMatrixID;
    };
}