#pragma once

#include "Universe.hpp"
#include "core/world/server_handle.hpp"

namespace world::client {
    /// Whole universe container in client with in-memory server
    class LocalUniverse final: public Universe {
    public:
        LocalUniverse(const login&, server_handle *const handle, const std::string& contouring);
        ~LocalUniverse();

        void update(cell_pos pos, float deltaTime) override;
        void emit(const action::packet &) override;

        node_id getPlayerId() const override { return handle->entityId; }
        virtual mutex::abstract_shared_guard<Elements>::handle getElements() const override { return handle->elements.lock_shared_abstract(); };

        bool isRunning() const override { return handle->running; }

    protected:
        server_handle *const handle;
    };
}